# Welcome to the Filters demo
print('SimpleITK Filters')

# Every demo starts by importing the SimpleITK module
import SimpleITK as sitk
import numpy as np

# Find some data
import os
dataDir = "/Users/desm2239/Dropbox/IMN530/html/Demos/demoRehaussementContour/"
image = sitk.ReadImage ( dataDir + "T1.png" )
image_a = sitk.GetArrayFromImage(image)
max_I   = np.max(image_a)
image_n = image_a / max_I
image = sitk.GetImageFromArray(image_n)
print(max_I)

# adding 10% noise
noise = 50*np.random.random(image.GetSize())
noiseImage = sitk.GetImageFromArray(noise)
sitk.Show ( image )
sitk.Show ( sitk.Add(sitk.Cast (image, sitk.sitkFloat64), noiseImage) )


# Gradient computation
sitk.Show ( sitk.Gradient ( image ), "Gradient" )
sitk.Show ( sitk.GradientMagnitude ( image ), "Gradient Magnitude" )

# Sharpen
sitk.Show ( sitk.LaplacianSharpening ( image ), "Sharp" )

# Canny edges
sitk.Show ( sitk.CannyEdgeDetection ( sitk.Cast ( image, sitk.sitkFloat32 ) ), "Canny" )


# Zero crossing of the Laplacian
sitk.Show ( sitk.ZeroCrossingBasedEdgeDetection( sitk.Cast ( image, sitk.sitkFloat32 ) ), "Zero crossing" )


image = sitk.Add(sitk.Cast (image, sitk.sitkFloat64), noiseImage)
# Linear filtering - isotropic filtering
sitk.Show ( sitk.SmoothingRecursiveGaussian ( image, 0.5 ) )
sitk.Show ( sitk.SmoothingRecursiveGaussian ( image, 2.0 ) )
sitk.Show ( sitk.SmoothingRecursiveGaussian ( image, 5.0 ) )

# time step tau and number iterations computed automatically
sitk.Show ( sitk.GradientAnisotropicDiffusion ( sitk.Cast ( image, sitk.sitkFloat32 ) ), "Anisotropic Diffusion" )

# time step tau = 0.01
sitk.Show ( sitk.GradientAnisotropicDiffusion ( sitk.Cast ( image, sitk.sitkFloat32 ), 0.01 ), "Anisotropic Diffusion" )

# time step 0.0025, regardez la doc!
sitk.Show ( sitk.GradientAnisotropicDiffusion ( sitk.Cast ( image, sitk.sitkFloat32 ), 0.0025 ), "Anisotropic Diffusion" )

# Median filtering
sitk.Show( sitk.Median( sitk.Cast ( image, sitk.sitkFloat32 ), (2, 2) ), "Median filter" )
# Bilateral filtering
sitk.Show( sitk.Bilateral( sitk.Cast ( image, sitk.sitkFloat32 ), 4.0, 50.0), "Bilateral filter" )
sitk.Show( sitk.Bilateral( sitk.Cast ( image, sitk.sitkFloat32 ), 2.0, 25.0), "Bilateral filter" )


