import numpy as np
from matplotlib import pyplot as plt
from matplotlib import image as mpimg
from scipy.signal import convolve2d

plt.title("Anatomical T1 Image")
plt.xlabel("X pixel scaling")
plt.ylabel("Y pixels scaling")

t1 = mpimg.imread("T1.png")
plt.imshow(t1, cmap='gray')
plt.show()

# y derivative
t1_y = convolve2d( t1, [[0, -1, 1,]] );
plt.imshow(t1_y, cmap='gray')
plt.show()

# x derivative
t1_x = convolve2d( t1, [[0], [-1], [1]] );
plt.imshow(t1_x, cmap='gray')
plt.show()



# Laplacian
L = [[ 0, 1, 0], [1, -4, 1], [0, 1, 0]]
t1_L = convolve2d( t1, L, 'same' );
plt.imshow(t1_L, cmap='gray')
plt.show()


# contour enhancement
ContourEnhancement = [[ 0, -1, 0], [-1, 5, -1], [0, -1, 0]]
t1_c = convolve2d( t1, ContourEnhancement, 'same' );
fig, axs = plt.subplots(1, 2)
#axs[0].imshow(t1[100:150,100:150], cmap='gray')
#axs[1].imshow(t1_c[100:150,100:150], cmap='gray')
axs[0].imshow(t1[50:100,100:150], cmap='gray')
axs[1].imshow(t1_c[50:100,100:150], cmap='gray')
plt.show()





